## notary 0.1~ds1

=== Makefile ===
# Set an output prefix, which is the local directory if not specified
PREFIX?=$(shell pwd)

# Populate version variables
# Add to compile time flags
NOTARY_PKG := github.com/docker/notary
NOTARY_VERSION := $(shell cat NOTARY_VERSION)
GITCOMMIT := $(shell git rev-parse --short HEAD)
GITUNTRACKEDCHANGES := $(shell git status --porcelain --untracked-files=no)
ifneq ($(GITUNTRACKEDCHANGES),)
GITCOMMIT := $(GITCOMMIT)-dirty
endif
CTIMEVAR=-X $(NOTARY_PKG)/version.GitCommit=$(GITCOMMIT) -X $(NOTARY_PKG)/version.NotaryVersion=$(NOTARY_VERSION)
GO_LDFLAGS=-ldflags "-w $(CTIMEVAR)"
GO_LDFLAGS_STATIC=-ldflags "-w $(CTIMEVAR) -extldflags -static"
GOOSES = darwin freebsd linux
GOARCHS = amd64
NOTARY_BUILDTAGS ?= pkcs11
GO_EXC = go
NOTARYDIR := /go/src/github.com/docker/notary

# check to be sure pkcs11 lib is always imported with a build tag
GO_LIST_PKCS11 := $(shell go list -e -f '{{join .Deps "\n"}}' ./... | xargs go list -e -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | grep -q pkcs11)
ifeq ($(GO_LIST_PKCS11),)
$(info pkcs11 import was not found anywhere without a build tag, yay)
else
$(error You are importing pkcs11 somewhere and not using a build tag)
endif

_empty :=
_space := $(empty) $(empty)

# go cover test variables
COVERDIR=.cover
COVERPROFILE=$(COVERDIR)/cover.out
COVERMODE=count
PKGS = $(shell go list ./... | tr '\n' ' ')

GO_VERSION = $(shell go version | awk '{print $$3}')

.PHONY: clean all fmt vet lint build test binaries cross cover docker-images notary-dockerfile
.DELETE_ON_ERROR: cover
.DEFAULT: default

go_version:
ifneq ("$(GO_VERSION)", "go1.5.1")
	$(error Requires go version 1.5.1 - found $(GO_VERSION))
else
	@echo
endif


all: AUTHORS clean fmt vet fmt lint build test binaries

AUTHORS: .git/HEAD
	git log --format='%aN <%aE>' | sort -fu > $@

# This only needs to be generated by hand when cutting full releases.
version/version.go:
	./version/version.sh > $@

${PREFIX}/bin/notary-server: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@godep go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-server

${PREFIX}/bin/notary: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@godep go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary

${PREFIX}/bin/notary-signer: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@godep go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-signer

vet: go_version
	@echo "+ $@"
	@test -z "$$(go tool vet -printf=false . 2>&1 | grep -v Godeps/_workspace/src/ | tee /dev/stderr)"

fmt:
	@echo "+ $@"
	@test -z "$$(gofmt -s -l .| grep -v .pb. | grep -v Godeps/_workspace/src/ | tee /dev/stderr)"

lint:
	@echo "+ $@"
	@test -z "$$(golint ./... | grep -v .pb. | grep -v Godeps/_workspace/src/ | tee /dev/stderr)"

build: go_version
	@echo "+ $@"
	@go build -tags "${NOTARY_BUILDTAGS}" -v ${GO_LDFLAGS} ./...

test: TESTOPTS =
test: go_version
	@echo "+ $@ $(TESTOPTS)"
	go test -tags "${NOTARY_BUILDTAGS}" $(TESTOPTS) ./...

test-full: vet lint
	@echo "+ $@"
	go test -tags "${NOTARY_BUILDTAGS}" -v ./...

protos:
	@protoc --go_out=plugins=grpc:. proto/*.proto

# This allows coverage for a package to come from tests in different package.
# Requires that the following:
# go get github.com/wadey/gocovmerge; go install github.com/wadey/gocovmerge
#
# be run first

define gocover
$(GO_EXC) test $(OPTS) $(TESTOPTS) -covermode="$(COVERMODE)" -coverprofile="$(COVERDIR)/$(subst /,-,$(1)).$(subst $(_space),.,$(NOTARY_BUILDTAGS)).cover" "$(1)" || exit 1;
endef

gen-cover: go_version
	@mkdir -p "$(COVERDIR)"
	$(foreach PKG,$(PKGS),$(call gocover,$(PKG)))

cover: GO_EXC := go
       OPTS = -tags "${NOTARY_BUILDTAGS}" -coverpkg "$(shell ./coverpkg.sh $(1) $(NOTARY_PKG))"
cover: gen-cover covmerge
	@go tool cover -html="$(COVERPROFILE)"

# Codecov knows how to merge multiple coverage files
ci: OPTS = -tags "${NOTARY_BUILDTAGS}" -race -coverpkg "$(shell ./coverpkg.sh $(1) $(NOTARY_PKG))"
    GO_EXC := godep go
ci: gen-cover

covmerge:
	@gocovmerge $(shell ls -1 $(COVERDIR)/* | tr "\n" " ") > $(COVERPROFILE)
	@go tool cover -func="$(COVERPROFILE)"

clean-protos:
	@rm proto/*.pb.go

binaries: go_version ${PREFIX}/bin/notary-server ${PREFIX}/bin/notary ${PREFIX}/bin/notary-signer
	@echo "+ $@"

define template
mkdir -p ${PREFIX}/cross/$(1)/$(2);
GOOS=$(1) GOARCH=$(2) CGO_ENABLED=0 go build -o ${PREFIX}/cross/$(1)/$(2)/notary -a -tags "static_build netgo" -installsuffix netgo ${GO_LDFLAGS_STATIC} ./cmd/notary;
endef

cross: go_version
	$(foreach GOARCH,$(GOARCHS),$(foreach GOOS,$(GOOSES),$(call template,$(GOOS),$(GOARCH))))


notary-dockerfile:
	@docker build --rm --force-rm -t notary .

server-dockerfile:
	@docker build --rm --force-rm -f Dockerfile.server -t notary-server .

signer-dockerfile:
	@docker build --rm --force-rm -f Dockerfile.signer -t notary-signer .

docker-images: notary-dockerfile server-dockerfile signer-dockerfile

shell: notary-dockerfile
	docker run --rm -it -v $(CURDIR)/cross:$(NOTARYDIR)/cross -v $(CURDIR)/bin:$(NOTARYDIR)/bin notary bash


clean:
	@echo "+ $@"
	@rm -rf "$(COVERDIR)"
	@rm -rf "${PREFIX}/bin/notary-server" "${PREFIX}/bin/notary" "${PREFIX}/bin/notary-signer"

=== debian/changelog ===
notary (0.1~ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release (Closes: #818439).

  [ Tim Potter ]
  * Update to latest upstream version and add new dependencies
    (Closes: #810777).
  * Refresh d/patches to reflect upstream work and run more tests.

  [ Dmitry Smirnov ]
  * Standards-Version: 3.9.7.
  * Build-Depends += "golang-github-bugsnag-bugsnag-go-dev".
  * Dropped obsolete "no-bugsnag.patch".
  * Ignore test failures.

 -- Dmitry Smirnov <onlyjob@debian.org>  Thu, 17 Mar 2016 18:45:06 +1100

notary (0.0~git20150801.0.8e8122e-2) unstable; urgency=medium

  * Swap Build-Depends relations for buildability

 -- Tianon Gravi <tianon@debian.org>  Wed, 28 Oct 2015 10:35:25 -0700

notary (0.0~git20150801.0.8e8122e-1) unstable; urgency=medium

  * Initial release (Closes: #797660)

 -- Tianon Gravi <tianon@debian.org>  Fri, 23 Oct 2015 07:22:08 -0700

=== debian/control ===
Source: notary
Section: devel
Priority: extra
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Tianon Gravi <tianon@debian.org>
Build-Depends: debhelper (>= 9),
               dh-golang,
               golang-docker-dev | golang-github-docker-docker-dev,
               golang-ed25519-dev | golang-github-agl-ed25519-dev,
               golang-github-data-dog-go-sqlmock-dev,
               golang-github-bugsnag-bugsnag-go-dev,
               golang-github-docker-distribution-dev (>= 2.2.0~),
               golang-github-dvsekhvalnov-jose2go-dev,
               golang-github-endophage-gotuf-dev,
               golang-github-go-sql-driver-mysql-dev,
               golang-github-gorilla-mux-dev,
               golang-github-jinzhu-gorm-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-miekg-pkcs11-dev,
               golang-github-mitchellh-go-homedir-dev,
               golang-github-olekukonko-tablewriter-dev,
               golang-github-sirupsen-logrus-dev | golang-logrus-dev,
               golang-github-spf13-cobra-dev,
               golang-github-spf13-viper-dev,
               golang-github-stretchr-testify-dev | golang-testify-dev,
               golang-github-tent-canonical-json-go-dev,
               golang-go,
               golang-golang-x-net-dev (>= 0.0+git20160110~),
               golang-google-grpc-dev (>= 0.0~git20151002~),
               golang-goprotobuf-dev | golang-github-golang-protobuf-dev,
               golang-prometheus-client-dev
Standards-Version: 3.9.7
Homepage: https://github.com/docker/notary
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-go/packages/golang-github-docker-notary.git
Vcs-Git: git://anonscm.debian.org/pkg-go/packages/golang-github-docker-notary.git
XS-Go-Import-Path: github.com/docker/notary

Package: notary
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: tool for running and interacting with trusted collections
 The Notary project comprises a server (cmd/notary-server) and a client
 (cmd/notary) for running and interacting with trusted collections.
 .
 Notary aims to make the internet more secure by making it easy for people to
 publish and verify content. We often rely on TLS to secure our communications
 with a web server which is inherently flawed, as any compromise of the server
 enables malicious content to be substituted for the legitimate content.
 .
 With Notary, publishers can sign their content offline using keys kept highly
 secure. Once the publisher is ready to make the content available, they can
 push their signed trusted collection to a Notary Server.
 .
 This package contains the binaries/tools.

Package: golang-github-docker-notary-dev
Architecture: all
Depends: golang-github-agl-ed25519-dev | golang-ed25519-dev,
         golang-github-data-dog-go-sqlmock-dev,
         golang-github-bugsnag-bugsnag-go-dev,
         golang-github-docker-distribution-dev (>= 2.2.0~),
         golang-github-docker-docker-dev | golang-docker-dev,
         golang-github-dvsekhvalnov-jose2go-dev,
         golang-github-endophage-gotuf-dev,
         golang-github-go-sql-driver-mysql-dev,
         golang-github-golang-protobuf-dev | golang-goprotobuf-dev,
         golang-github-gorilla-mux-dev,
         golang-github-jinzhu-gorm-dev,
         golang-github-mattn-go-sqlite3-dev,
         golang-github-miekg-pkcs11-dev,
         golang-github-mitchellh-go-homedir-dev,
         golang-github-olekukonko-tablewriter-dev,
         golang-github-sirupsen-logrus-dev | golang-logrus-dev,
         golang-github-spf13-cobra-dev,
         golang-github-spf13-viper-dev,
         golang-github-stretchr-testify-dev | golang-testify-dev,
         golang-github-tent-canonical-json-go-dev,
         golang-golang-x-net-dev (>= 0.0+git20160110~),
         golang-google-grpc-dev (>= 0.0~git20151002~),
         golang-prometheus-client-dev,
         ${misc:Depends},
         ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: tool for running and interacting with trusted collections
 The Notary project comprises a server (cmd/notary-server) and a client
 (cmd/notary) for running and interacting with trusted collections.
 .
 Notary aims to make the internet more secure by making it easy for people to
 publish and verify content. We often rely on TLS to secure our communications
 with a web server which is inherently flawed, as any compromise of the server
 enables malicious content to be substituted for the legitimate content.
 .
 With Notary, publishers can sign their content offline using keys kept highly
 secure. Once the publisher is ready to make the content available, they can
 push their signed trusted collection to a Notary Server.
 .
 This package contains the source.

=== debian/rules ===
#!/usr/bin/make -f

export DH_GOLANG_INSTALL_ALL := 1

%:
	dh $@ --buildsystem=golang --with=golang

override_dh_auto_test:
	-dh_auto_test

override_dh_auto_install:
	dh_auto_install
	# Remove extra license files - contents are reflected in d/copyright
	$(RM) -v \
            debian/tmp/usr/share/gocode/src/github.com/docker/notary/LICENSE \
            debian/tmp/usr/share/gocode/src/github.com/docker/notary/*/LICENSE

=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/notary-$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/,\
dversionmangle=s/[~+]ds\d*$//,\
repacksuffix=~ds1 \
 https://github.com/docker/notary/releases \
 .*/archive/v?(\d[\d\.]+)\.tar\.gz

## notary 0.6.1~ds1

=== debian/changelog ===
notary (0.6.1~ds1-3) unstable; urgency=medium

  * Team upload.
  * Regenerate some test certs since they are expired (Closes: #924119)

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 04 Apr 2019 00:12:00 +0800

notary (0.6.1~ds1-2) unstable; urgency=medium

  * New upstream patch to remove "golang-ed25519-dev" dependency.

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 11 Jul 2018 11:34:36 +1000

notary (0.6.1~ds1-1) unstable; urgency=medium

  * Team upload
  * Fixed FTBFS (Closes: #861546, #835782).

  [ Dmitry Smirnov ]
  * New namespace github.com/theupdateframework/notary
  * Provides: golang-github-theupdateframework-notary-dev
  * Testsuite: autopkgtest-pkg-go
  * Standards-Version: 4.1.4; Priority: optional.
  * Updates Vcs URLs.
  * golang-go --> golang-any
  * debhelper to version 11; compat to version 10.
  * logrus dependency update.
  * new patch to disable failing networking test.
  * L: duplicate-short-description
  * Build-Depends:
    - golang-github-docker-distribution-dev

  [ Arnaud Rebillout ]
  * New upstream version 0.6.1~ds1
  * Remove patches applied upstream
  * Remove obsolete patches
  * lintian: no more embedded yaml, add a few overrides
  * docs: include changelog and roadmap
  * rules: install test fixtures explicitly instead of using INSTALL_ALL
  * rules: enable pkcs11 build tag
  * rules: enable tests
  * control: update dependencies
  * control: update description
  * control: add myself to uploaders

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 20 Jun 2018 01:16:39 +1000

notary (0.2.0~ds1-1) unstable; urgency=medium

  [ Tianon Gravi ]
  * Update to 0.2.0 upstream release

  [ Paul Tagliamonte ]
  * Remove Built-Using from arch:all -dev package

  [ Alexandre Viau ]
  * Point Vcs-* urls to salsa.debian.org.

 -- Alexandre Viau <aviau@debian.org>  Mon, 02 Apr 2018 16:03:02 -0400

=== debian/control ===
Source: notary
Section: devel
Priority: optional
Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Arnaud Rebillout <arnaud.rebillout@collabora.com>,
           Tianon Gravi <tianon@debian.org>
Build-Depends: debhelper (>= 11~),
               dh-golang,
               golang-any,
               golang-github-bugsnag-bugsnag-go-dev,
               golang-github-cloudflare-cfssl-dev,
               golang-github-docker-distribution-dev (>= 2.2.0~),
               golang-github-docker-go-connections-dev (>= 0.3.0~),
               golang-github-docker-go-dev,
               golang-github-dvsekhvalnov-jose2go-dev,
               golang-github-go-sql-driver-mysql-dev,
               golang-github-gorilla-mux-dev,
               golang-github-jinzhu-gorm-dev,
               golang-github-lib-pq-dev,
               golang-github-mattn-go-sqlite3-dev,
               golang-github-miekg-pkcs11-dev (>= 0.0~git20160602~),
               golang-github-prometheus-client-golang-dev,
               golang-github-shopify-logrus-bugsnag-dev (>= 0.0~git20171204~),
               golang-github-sirupsen-logrus-dev (>= 1.0.2~),
               golang-github-spf13-cobra-dev,
               golang-github-spf13-viper-dev,
               golang-github-stretchr-testify-dev,
               golang-golang-x-crypto-dev,
               golang-golang-x-net-dev (>= 0.0+git20160110~),
               golang-golang-x-sys-dev,
               golang-google-grpc-dev (>= 0.0~git20151002~),
               golang-gopkg-gorethink-gorethink.v3-dev,
               golang-goprotobuf-dev,
               openssl
Standards-Version: 4.1.4
Homepage: https://github.com/theupdateframework/notary
Vcs-Browser: https://salsa.debian.org/go-team/packages/notary
Vcs-Git: https://salsa.debian.org/go-team/packages/notary.git
XS-Go-Import-Path: github.com/theupdateframework/notary
Testsuite: autopkgtest-pkg-go

Package: notary
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Built-Using: ${misc:Built-Using}
Description: tool for running and interacting with trusted collections
 Notary is a project that allows anyone to have trust over arbitrary
 collections of data.
 .
 The Notary project comprises a server (cmd/notary-server) and a client
 (cmd/notary) for running and interacting with trusted collections.
 .
 Notary aims to make the internet more secure by making it easy for people to
 publish and verify content. We often rely on TLS to secure our communications
 with a web server which is inherently flawed, as any compromise of the server
 enables malicious content to be substituted for the legitimate content.
 .
 With Notary, publishers can sign their content offline using keys kept highly
 secure. Once the publisher is ready to make the content available, they can
 push their signed trusted collection to a Notary Server.
 .
 Consumers, having acquired the publisher's public key through a secure
 channel, can then communicate with any notary server or (insecure) mirror,
 relying only on the publisher's key to determine the validity and integrity
 of the received content.
 .
 This package contains the binaries/tools.

Package: golang-github-docker-notary-dev
Provides: golang-github-theupdateframework-notary-dev
Architecture: all
Depends: ${misc:Depends},
         golang-github-bugsnag-bugsnag-go-dev,
         golang-github-cloudflare-cfssl-dev,
         golang-github-docker-go-connections-dev (>= 0.3.0~),
         golang-github-docker-go-dev,
         golang-github-dvsekhvalnov-jose2go-dev,
         golang-github-go-sql-driver-mysql-dev,
         golang-github-gorilla-mux-dev,
         golang-github-jinzhu-gorm-dev,
         golang-github-lib-pq-dev,
         golang-github-mattn-go-sqlite3-dev,
         golang-github-miekg-pkcs11-dev (>= 0.0~git20160602~),
         golang-github-prometheus-client-golang-dev,
         golang-github-shopify-logrus-bugsnag-dev (>= 0.0~git20171204~),
         golang-github-sirupsen-logrus-dev (>= 1.0.2~),
         golang-github-spf13-cobra-dev,
         golang-github-spf13-viper-dev,
         golang-github-stretchr-testify-dev,
         golang-golang-x-crypto-dev,
         golang-golang-x-net-dev (>= 0.0+git20160110~),
         golang-golang-x-sys-dev,
         golang-google-grpc-dev (>= 0.0~git20151002~),
         golang-gopkg-gorethink-gorethink.v3-dev,
         golang-goprotobuf-dev
Description: library for running and interacting with trusted collections
 Notary is a project that allows anyone to have trust over arbitrary
 collections of data.
 .
 The Notary project comprises a server (cmd/notary-server) and a client
 (cmd/notary) for running and interacting with trusted collections.
 .
 Notary aims to make the internet more secure by making it easy for people to
 publish and verify content. We often rely on TLS to secure our communications
 with a web server which is inherently flawed, as any compromise of the server
 enables malicious content to be substituted for the legitimate content.
 .
 With Notary, publishers can sign their content offline using keys kept highly
 secure. Once the publisher is ready to make the content available, they can
 push their signed trusted collection to a Notary Server.
 .
 Consumers, having acquired the publisher's public key through a secure
 channel, can then communicate with any notary server or (insecure) mirror,
 relying only on the publisher's key to determine the validity and integrity
 of the received content.
 .
 This package contains the source.

=== debian/rules ===
#!/usr/bin/make -f

## Depends += gogoprotobuf golang-goprotobuf-dev
#export DH_GOLANG_GO_GENERATE := 1   :: this should be enabled

export DH_GOLANG_INSTALL_EXTRA := fixtures
GOPKG     := github.com/theupdateframework/notary
BUILDDIR  := $(CURDIR)/_build
BUILDTAGS := pkcs11

%:
	dh $@ --builddirectory=$(BUILDDIR) \
	      --buildsystem=golang \
	      --with=golang

override_dh_auto_configure:
	# Note(zhsj): some certs are expired and cause test failures.
	# but there's no need to regenerate certs which need cfssljson tool.
	# And I don't want to add another Build-Depends.
	sed -i '/command -v cfssljson/i exit 0' ./fixtures/regenerateTestingCerts.sh
	cd fixtures && ./regenerateTestingCerts.sh
	dh_auto_configure

override_dh_auto_build:
	dh_auto_build -- -tags "$(BUILDTAGS)"

override_dh_auto_install:
	# There's no reason to ship this script as it's not needed for the tests,
	# and will cause Lintian to warn about a 'script-not-executable'.
	rm $(BUILDDIR)/src/$(GOPKG)/fixtures/regenerateTestingCerts.sh
	dh_auto_install

## notary 0.6.1~ds2

=== Makefile ===
# Set an output prefix, which is the local directory if not specified
PREFIX?=$(shell pwd)

# Populate version variables
# Add to compile time flags
NOTARY_PKG := github.com/theupdateframework/notary
NOTARY_VERSION := $(shell cat NOTARY_VERSION)
GITCOMMIT := $(shell git rev-parse --short HEAD)
GITUNTRACKEDCHANGES := $(shell git status --porcelain --untracked-files=no)
ifneq ($(GITUNTRACKEDCHANGES),)
GITCOMMIT := $(GITCOMMIT)-dirty
endif
CTIMEVAR=-X $(NOTARY_PKG)/version.GitCommit=$(GITCOMMIT) -X $(NOTARY_PKG)/version.NotaryVersion=$(NOTARY_VERSION)
GO_LDFLAGS=-ldflags "-w $(CTIMEVAR)"
GO_LDFLAGS_STATIC=-ldflags "-w $(CTIMEVAR) -extldflags -static"
GOOSES = darwin linux windows
NOTARY_BUILDTAGS ?= pkcs11
NOTARYDIR := /go/src/github.com/theupdateframework/notary

GO_VERSION := $(shell go version | grep "1\.\(7\|8\|9\|10\)\(\.[0-9]+\)*\|devel")
# check to make sure we have the right version. development versions of Go are
# not officially supported, but allowed for building

ifeq ($(strip $(GO_VERSION))$(SKIPENVCHECK),)
$(error Bad Go version - please install Go >= 1.7)
endif

# check to be sure pkcs11 lib is always imported with a build tag
GO_LIST_PKCS11 := $(shell go list -tags "${NOTARY_BUILDTAGS}" -e -f '{{join .Deps "\n"}}' ./... | grep -v /vendor/ | xargs go list -e -f '{{if not .Standard}}{{.ImportPath}}{{end}}' | grep -q pkcs11)
ifeq ($(GO_LIST_PKCS11),)
$(info pkcs11 import was not found anywhere without a build tag, yay)
else
$(error You are importing pkcs11 somewhere and not using a build tag)
endif

_empty :=
_space := $(empty) $(empty)

# go cover test variables
COVERPROFILE?=coverage.txt
COVERMODE=atomic
PKGS ?= $(shell go list -tags "${NOTARY_BUILDTAGS}" ./... | grep -v /vendor/ | tr '\n' ' ')

.PHONY: clean all lint build test binaries cross cover docker-images notary-dockerfile
.DELETE_ON_ERROR: cover
.DEFAULT: default

all: clean lint build test binaries

# This only needs to be generated by hand when cutting full releases.
version/version.go:
	./version/version.sh > $@

${PREFIX}/bin/notary-server: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-server

${PREFIX}/bin/notary: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary

${PREFIX}/bin/notary-signer: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/notary-signer

${PREFIX}/bin/escrow: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@go build -tags ${NOTARY_BUILDTAGS} -o $@ ${GO_LDFLAGS} ./cmd/escrow

ifeq ($(shell uname -s),Darwin)
${PREFIX}/bin/static/notary-server:
	@echo "notary-server: static builds not supported on OS X"

${PREFIX}/bin/static/notary-signer:
	@echo "notary-signer: static builds not supported on OS X"

${PREFIX}/bin/static/notary:
	@echo "notary: static builds not supported on OS X"
else
${PREFIX}/bin/static/notary-server: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@(export CGO_ENABLED=0; go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary-server)

${PREFIX}/bin/static/notary-signer: NOTARY_VERSION $(shell find . -type f -name '*.go')
	@echo "+ $@"
	@(export CGO_ENABLED=0; go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary-signer)

${PREFIX}/bin/static/notary:
	@echo "+ $@"
	@go build -tags "${NOTARY_BUILDTAGS} netgo" -o $@ ${GO_LDFLAGS_STATIC} ./cmd/notary
endif


# run all lint functionality - excludes Godep directory, vendoring, binaries, python tests, and git files
lint:
	@echo "+ $@: golint, go vet, go fmt, gocycle, misspell, ineffassign"
	# golint
	@test -z "$(shell find . -type f -name "*.go" -not -path "./vendor/*" -not -name "*.pb.*" -exec golint {} \; | tee /dev/stderr)"
	# gofmt
	@test -z "$$(gofmt -s -l .| grep -v .pb. | grep -v vendor/ | tee /dev/stderr)"
	# govet
ifeq ($(shell uname -s), Darwin)
	@test -z "$(shell find . -iname *test*.go | grep -v _test.go | grep -v vendor | xargs echo "This file should end with '_test':"  | tee /dev/stderr)"
else
	@test -z "$(shell find . -iname *test*.go | grep -v _test.go | grep -v vendor | xargs -r echo "This file should end with '_test':"  | tee /dev/stderr)"
endif
	@test -z "$$(go tool vet -printf=false . 2>&1 | grep -v vendor/ | tee /dev/stderr)"
	# gocyclo - we require cyclomatic complexity to be < 16
	@test -z "$(shell find . -type f -name "*.go" -not -path "./vendor/*" -not -name "*.pb.*" -exec gocyclo -over 15 {} \; | tee /dev/stderr)"
	# misspell - requires that the following be run first:
	#    go get -u github.com/client9/misspell/cmd/misspell
	@test -z "$$(find . -type f | grep -v vendor/ | grep -v bin/ | grep -v misc/ | grep -v .git/ | grep -v \.pdf | xargs misspell | tee /dev/stderr)"
	# ineffassign - requires that the following be run first:
	#    go get -u github.com/gordonklaus/ineffassign
	@test -z "$(shell find . -type f -name "*.go" -not -path "./vendor/*" -not -name "*.pb.*" -exec ineffassign {} \; | tee /dev/stderr)"
	# gas - requires that the following be run first:
	#    go get -u github.com/HewlettPackard/gas
	# @gas -skip=vendor -skip=*/*_test.go -skip=*/*/*_test.go -fmt=csv -out=gas_output.csv ./... && test -z "$$(cat gas_output.csv | tee /dev/stderr)"

build:
	@echo "+ $@"
	@go build -tags "${NOTARY_BUILDTAGS}" -v ${GO_LDFLAGS} $(PKGS)

# When running `go test ./...`, it runs all the suites in parallel, which causes
# problems when running with a yubikey
test: TESTOPTS =
test:
	@echo Note: when testing with a yubikey plugged in, make sure to include 'TESTOPTS="-p 1"'
	@echo "+ $@ $(TESTOPTS)"
	@echo
	go test -tags "${NOTARY_BUILDTAGS}" $(TESTOPTS) $(PKGS)

integration: TESTDB = mysql
integration: clean
	buildscripts/integrationtest.sh $(TESTDB)

testdb: TESTDB = mysql
testdb:
	buildscripts/dbtests.sh $(TESTDB)

protos:
	@protoc --go_out=plugins=grpc:. proto/*.proto

# This allows coverage for a package to come from tests in different package.
# Requires that the following:
# go get github.com/wadey/gocovmerge; go install github.com/wadey/gocovmerge
#
# be run first
gen-cover:
gen-cover:
	@python -u buildscripts/covertest.py --tags "$(NOTARY_BUILDTAGS)" --pkgs="$(PKGS)" --testopts="${TESTOPTS}" --debug

# Generates the cover binaries and runs them all in serial, so this can be used
# run all tests with a yubikey without any problems
cover: gen-cover covmerge
	@go tool cover -html="$(COVERPROFILE)"

# Generates the cover binaries and runs them all in serial, so this can be used
# run all tests with a yubikey without any problems
ci: override TESTOPTS = -race
# Codecov knows how to merge multiple coverage files, so covmerge is not needed
ci: gen-cover

yubikey-tests: override PKGS = github.com/theupdateframework/notary/cmd/notary github.com/theupdateframework/notary/trustmanager/yubikey
yubikey-tests: ci

covmerge:
	@gocovmerge $(shell find . -name coverage*.txt | tr "\n" " ") > $(COVERPROFILE)
	@go tool cover -func="$(COVERPROFILE)"

clean-protos:
	@rm proto/*.pb.go

client: ${PREFIX}/bin/notary
	@echo "+ $@"

binaries: ${PREFIX}/bin/notary-server ${PREFIX}/bin/notary ${PREFIX}/bin/notary-signer
	@echo "+ $@"

escrow: ${PREFIX}/bin/escrow
	@echo "+ $@"

static: ${PREFIX}/bin/static/notary-server ${PREFIX}/bin/static/notary-signer ${PREFIX}/bin/static/notary
	@echo "+ $@"

notary-dockerfile:
	@docker build --rm --force-rm -t notary .

server-dockerfile:
	@docker build --rm --force-rm -f server.Dockerfile -t notary-server .

signer-dockerfile:
	@docker build --rm --force-rm -f signer.Dockerfile -t notary-signer .

docker-images: notary-dockerfile server-dockerfile signer-dockerfile

shell: notary-dockerfile
	docker run --rm -it -v $(CURDIR)/cross:$(NOTARYDIR)/cross -v $(CURDIR)/bin:$(NOTARYDIR)/bin notary bash

cross:
	@rm -rf $(CURDIR)/cross
	@docker build --rm --force-rm -t notary -f cross.Dockerfile .
	docker run --rm -v $(CURDIR)/cross:$(NOTARYDIR)/cross -e CTIMEVAR="${CTIMEVAR}" -e NOTARY_BUILDTAGS=$(NOTARY_BUILDTAGS) notary buildscripts/cross.sh $(GOOSES)

clean:
	@echo "+ $@"
	@rm -rf .cover cross
	find . -name coverage.txt -delete
	@rm -rf "${PREFIX}/bin/notary-server" "${PREFIX}/bin/notary" "${PREFIX}/bin/notary-signer"
	@rm -rf "${PREFIX}/bin/static"

=== docs/Makefile ===
.PHONY: all binary build cross default docs docs-build docs-shell shell test test-unit test-integration test-integration-cli test-docker-py validate

# env vars passed through directly to Docker's build scripts
# to allow things like `make DOCKER_CLIENTONLY=1 binary` easily
# `docs/sources/contributing/devenvironment.md ` and `project/PACKAGERS.md` have some limited documentation of some of these
DOCKER_ENVS := \
	-e BUILDFLAGS \
	-e DOCKER_CLIENTONLY \
	-e DOCKER_EXECDRIVER \
	-e DOCKER_GRAPHDRIVER \
	-e TESTDIRS \
	-e TESTFLAGS \
	-e TIMEOUT
# note: we _cannot_ add "-e DOCKER_BUILDTAGS" here because even if it's unset in the shell, that would shadow the "ENV DOCKER_BUILDTAGS" set in our Dockerfile, which is very important for our official builds

# to allow `make DOCSDIR=docs docs-shell` (to create a bind mount in docs)
DOCS_MOUNT := $(if $(DOCSDIR),-v $(CURDIR)/$(DOCSDIR):/$(DOCSDIR))

# to allow `make DOCSPORT=9000 docs`
DOCSPORT := 8000

# Get the IP ADDRESS
DOCKER_IP=$(shell python -c "import urlparse ; print urlparse.urlparse('$(DOCKER_HOST)').hostname or ''")
HUGO_BASE_URL=$(shell test -z "$(DOCKER_IP)" && echo localhost || echo "$(DOCKER_IP)")
HUGO_BIND_IP=0.0.0.0

GIT_BRANCH := $(shell git rev-parse --abbrev-ref HEAD 2>/dev/null)
DOCKER_IMAGE := docker$(if $(GIT_BRANCH),:$(GIT_BRANCH))
DOCKER_DOCS_IMAGE := docs-base$(if $(GIT_BRANCH),:$(GIT_BRANCH))


DOCKER_RUN_DOCS := docker run --rm -it $(DOCS_MOUNT) -e AWS_S3_BUCKET -e NOCACHE

# for some docs workarounds (see below in "docs-build" target)
GITCOMMIT := $(shell git rev-parse --short HEAD 2>/dev/null)

default: docs

docs: docs-build
	$(DOCKER_RUN_DOCS) -p $(if $(DOCSPORT),$(DOCSPORT):)8000 -e DOCKERHOST "$(DOCKER_DOCS_IMAGE)" hugo server --port=$(DOCSPORT) --baseUrl=$(HUGO_BASE_URL) --bind=$(HUGO_BIND_IP)

docs-draft: docs-build
	$(DOCKER_RUN_DOCS) -p $(if $(DOCSPORT),$(DOCSPORT):)8000 -e DOCKERHOST "$(DOCKER_DOCS_IMAGE)" hugo server --buildDrafts="true" --port=$(DOCSPORT) --baseUrl=$(HUGO_BASE_URL) --bind=$(HUGO_BIND_IP)


docs-shell: docs-build
	$(DOCKER_RUN_DOCS) -p $(if $(DOCSPORT),$(DOCSPORT):)8000 "$(DOCKER_DOCS_IMAGE)" bash


docs-build:
#	( git remote | grep -v upstream ) || git diff --name-status upstream/release..upstream/docs ./ > ./changed-files
#	echo "$(GIT_BRANCH)" > GIT_BRANCH
#	echo "$(AWS_S3_BUCKET)" > AWS_S3_BUCKET
#	echo "$(GITCOMMIT)" > GITCOMMIT
	docker build -t "$(DOCKER_DOCS_IMAGE)" .

=== debian/changelog ===
notary (0.6.1~ds2-5) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * New patch to fix FTBFS with golang-github-docker-distribution-dev >= 2.7.1
    (Closes: #944346).

  [ Arnaud Rebillout ]
  * Vendor prometheus-client-golang
  * New upstream version 0.6.1~ds2
  * Add upstream patch to fix test for go 1.13
  * Add upstream patch to build against latest docker/distribution
  * Add vendored NOTICE file
  * Make sure keys and certificates are not executable

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Thu, 06 Feb 2020 08:53:34 +0700

notary (0.6.1~ds1-4) unstable; urgency=medium

  * Team upload.
  * Backport fix from upstream to fix ftbfs with Go 1.12.
  * Add myself to uploaders.

 -- Michael Hudson-Doyle <mwhudson@debian.org>  Tue, 27 Aug 2019 20:47:14 +1200

=== debian/control ===
--- 
+++ 
@@ -3,13 +3,14 @@
 Priority: optional
 Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
 Uploaders: Arnaud Rebillout <arnaud.rebillout@collabora.com>,
+           Michael Hudson-Doyle <mwhudson@debian.org>,
            Tianon Gravi <tianon@debian.org>
 Build-Depends: debhelper (>= 11~),
                dh-golang,
                golang-any,
                golang-github-bugsnag-bugsnag-go-dev,
                golang-github-cloudflare-cfssl-dev,
-               golang-github-docker-distribution-dev (>= 2.2.0~),
+               golang-github-docker-distribution-dev (>= 2.7.1~),
                golang-github-docker-go-connections-dev (>= 0.3.0~),
                golang-github-docker-go-dev,
                golang-github-dvsekhvalnov-jose2go-dev,
@@ -19,7 +20,7 @@
                golang-github-lib-pq-dev,
                golang-github-mattn-go-sqlite3-dev,
                golang-github-miekg-pkcs11-dev (>= 0.0~git20160602~),
-               golang-github-prometheus-client-golang-dev,
+#               golang-github-prometheus-client-golang-dev,    # vendored
                golang-github-shopify-logrus-bugsnag-dev (>= 0.0~git20171204~),
                golang-github-sirupsen-logrus-dev (>= 1.0.2~),
                golang-github-spf13-cobra-dev,
@@ -81,7 +82,7 @@
          golang-github-lib-pq-dev,
          golang-github-mattn-go-sqlite3-dev,
          golang-github-miekg-pkcs11-dev (>= 0.0~git20160602~),
-         golang-github-prometheus-client-golang-dev,
+#         golang-github-prometheus-client-golang-dev,    # vendored
          golang-github-shopify-logrus-bugsnag-dev (>= 0.0~git20171204~),
          golang-github-sirupsen-logrus-dev (>= 1.0.2~),
          golang-github-spf13-cobra-dev,

=== debian/rules ===
--- 
+++ 
@@ -28,4 +28,7 @@
 	# There's no reason to ship this script as it's not needed for the tests,
 	# and will cause Lintian to warn about a 'script-not-executable'.
 	rm $(BUILDDIR)/src/$(GOPKG)/fixtures/regenerateTestingCerts.sh
+	# Some keys and certs are executable, Lintian says 'executable-not-elf-or-script' 
+	find $(BUILDDIR)/src/$(GOPKG)/fixtures/ -name '*.key' -executable -print | xargs chmod -x
+	find $(BUILDDIR)/src/$(GOPKG)/fixtures/ -name '*.crt' -executable -print | xargs chmod -x
 	dh_auto_install

=== debian/watch ===
# uscan(1) configuration file.
version=3

opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/notary-$1\.tar\.gz/,\
uversionmangle=s/(\d)[_\.\-\+]?(RC|rc|pre|dev|beta|alpha)[.]?(\d*)$/$1~$2$3/,\
dversionmangle=s/[~+]ds\d*$//,\
repacksuffix=~ds2 \
 https://github.com/theupdateframework/notary/releases \
 .*/archive/v?(\d[\d\.]+)\.tar\.gz

## notary 0.7.0%2Bds1

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*@ARCHIVE_EXT@)%@PACKAGE@-$1%, \
    dversionmangle=auto, \
    repacksuffix=+ds1" \
    https://github.com/notaryproject/notary/tags \
    (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## notary 0.7.0+ds1

=== debian/changelog ===
notary (0.7.0+ds1-3) unstable; urgency=medium

  * Team upload.
  * allow compilation against golang/protobuf@v1.3
  * Bump Standards-verison, no changes needed

 -- Reinhard Tartler <siretart@tauware.de>  Sun, 09 Jun 2024 14:15:58 -0400

notary (0.7.0+ds1-2) unstable; urgency=medium

  * Team upload
  * Add patch to fix FTBFS with libprotobuf-dev 3.21.9 (Closes: #1024844)
  * Replace transitional golang-goprotobuf-dev package
  * Add Multi-Arch hint
  * Update Standards-Version to 4.6.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 28 Nov 2022 20:16:41 +0800

notary (0.7.0+ds1-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit.

  [ Arnaud Rebillout ]
  * Update watch file (version 4, fixed for latest github changes)
  * Configure gbp for dep-14 branch naming, disable pristine-tar
  * Copy the vendored bits under debian/vendor
  * Drop the vendor tree entirely
  * Copy the debian vendor tree in the build directory
  * Add patch to fix the tests (broken with Go 1.17)
  * Update Go team email address
  * Update my emaill address, add myself to d/copyright
  * Bring repack suffix to +ds1 (prepare for new upstream version)
  * Drop patches applied upstream
  * Update build dependencies (rethinkdb)
  * Remove obsolete constraints from build deps
  * Remove ROADMAP from the docs
  * Enable (and fix) code generation
  * Switch to debhelper-compat 13
  * Update upstream url
  * Remove obsolete install and lintian-overrides file
  * Remove debian/clean
  * Bump Standards-Version (no change required)
  * Add Rules-Requires-Root: no

 -- Arnaud Rebillout <arnaudr@kali.org>  Sun, 23 Jan 2022 09:45:12 +0700

notary (0.6.1~ds2-6) unstable; urgency=medium

  * Team upload.
  * Disabled failing "TestNetworkError" (Closes: #954692).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 18 Apr 2020 11:35:33 +1000

=== debian/control ===
--- 
+++ 
@@ -1,44 +1,45 @@
 Source: notary
 Section: devel
 Priority: optional
-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
-Uploaders: Arnaud Rebillout <arnaud.rebillout@collabora.com>,
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Uploaders: Arnaud Rebillout <arnaudr@kali.org>,
            Michael Hudson-Doyle <mwhudson@debian.org>,
-           Tianon Gravi <tianon@debian.org>
-Build-Depends: debhelper (>= 11~),
+Rules-Requires-Root: no
+Build-Depends: debhelper-compat (= 13),
                dh-golang,
                golang-any,
                golang-github-bugsnag-bugsnag-go-dev,
                golang-github-cloudflare-cfssl-dev,
                golang-github-docker-distribution-dev (>= 2.7.1~),
-               golang-github-docker-go-connections-dev (>= 0.3.0~),
+               golang-github-docker-go-connections-dev,
                golang-github-docker-go-dev,
                golang-github-dvsekhvalnov-jose2go-dev,
                golang-github-go-sql-driver-mysql-dev,
+               golang-github-golang-protobuf-1-3-dev,
                golang-github-gorilla-mux-dev,
                golang-github-jinzhu-gorm-dev,
                golang-github-lib-pq-dev,
                golang-github-mattn-go-sqlite3-dev,
-               golang-github-miekg-pkcs11-dev (>= 0.0~git20160602~),
+               golang-github-miekg-pkcs11-dev,
 #               golang-github-prometheus-client-golang-dev,    # vendored
-               golang-github-shopify-logrus-bugsnag-dev (>= 0.0~git20171204~),
-               golang-github-sirupsen-logrus-dev (>= 1.0.2~),
+               golang-github-shopify-logrus-bugsnag-dev,
+               golang-github-sirupsen-logrus-dev,
                golang-github-spf13-cobra-dev,
                golang-github-spf13-viper-dev,
                golang-github-stretchr-testify-dev,
                golang-golang-x-crypto-dev,
-               golang-golang-x-net-dev (>= 0.0+git20160110~),
+               golang-golang-x-net-dev,
                golang-golang-x-sys-dev,
-               golang-google-grpc-dev (>= 0.0~git20151002~),
-               golang-gopkg-gorethink-gorethink.v3-dev,
-               golang-goprotobuf-dev,
-               openssl
-Standards-Version: 4.1.4
-Homepage: https://github.com/theupdateframework/notary
+               golang-google-grpc-dev,
+               golang-gopkg-rethinkdb-rethinkdb-go.v6-dev,
+               openssl,
+               protoc-gen-go-1-3
+Testsuite: autopkgtest-pkg-go
+Standards-Version: 4.7.0
+Homepage: https://github.com/notaryproject/notary
 Vcs-Browser: https://salsa.debian.org/go-team/packages/notary
 Vcs-Git: https://salsa.debian.org/go-team/packages/notary.git
 XS-Go-Import-Path: github.com/theupdateframework/notary
-Testsuite: autopkgtest-pkg-go
 
 Package: notary
 Architecture: any
@@ -70,30 +71,31 @@
 Package: golang-github-docker-notary-dev
 Provides: golang-github-theupdateframework-notary-dev
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          golang-github-bugsnag-bugsnag-go-dev,
          golang-github-cloudflare-cfssl-dev,
-         golang-github-docker-go-connections-dev (>= 0.3.0~),
+         golang-github-docker-go-connections-dev,
          golang-github-docker-go-dev,
          golang-github-dvsekhvalnov-jose2go-dev,
          golang-github-go-sql-driver-mysql-dev,
+         golang-github-golang-protobuf-1-3-dev | golang-github-golang-protobuf-1-5-dev,
          golang-github-gorilla-mux-dev,
          golang-github-jinzhu-gorm-dev,
          golang-github-lib-pq-dev,
          golang-github-mattn-go-sqlite3-dev,
-         golang-github-miekg-pkcs11-dev (>= 0.0~git20160602~),
+         golang-github-miekg-pkcs11-dev,
 #         golang-github-prometheus-client-golang-dev,    # vendored
-         golang-github-shopify-logrus-bugsnag-dev (>= 0.0~git20171204~),
-         golang-github-sirupsen-logrus-dev (>= 1.0.2~),
+         golang-github-shopify-logrus-bugsnag-dev,
+         golang-github-sirupsen-logrus-dev,
          golang-github-spf13-cobra-dev,
          golang-github-spf13-viper-dev,
          golang-github-stretchr-testify-dev,
          golang-golang-x-crypto-dev,
-         golang-golang-x-net-dev (>= 0.0+git20160110~),
+         golang-golang-x-net-dev,
          golang-golang-x-sys-dev,
-         golang-google-grpc-dev (>= 0.0~git20151002~),
-         golang-gopkg-gorethink-gorethink.v3-dev,
-         golang-goprotobuf-dev
+         golang-google-grpc-dev,
+         golang-gopkg-rethinkdb-rethinkdb-go.v6-dev
 Description: library for running and interacting with trusted collections
  Notary is a project that allows anyone to have trust over arbitrary
  collections of data.
